# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# perl_vendorlib/perl_vendorarch not defined by default prior to F-2
%{!?perl_vendorarch: %global perl_vendorarch %(eval "`perl -V:installvendorarch`"; echo $installvendorarch)}

# Note that this package fails to build on x86_64 systems later than RHEL3
# (possibly related to http://rt.cpan.org/Public/Bug/Display.html?id=23717)
# I suggest Sendmail::PMilter as a compatible alternative

Summary:	Perl module that lets you write mail filters for sendmail in Perl
Name:		perl-Sendmail-Milter
Version:	0.18
Release:	11.%{__distinit}%{__distvers}
License:	Sendmail
Group:		Development/Libraries
Url:		http://sourceforge.net/projects/sendmail-milter/
Source0:	http://search.cpan.org/CPAN/authors/id/C/CY/CYING/Sendmail-Milter-%{version}.tar.gz
Patch0:		Sendmail-Milter-0.18-build.patch
Patch1:		Sendmail-Milter-0.18-rt48644.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildRequires:	sendmail-devel >= 8.12, perl(ExtUtils::MakeMaker)
Requires:	sendmail >= 8.12, perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

# Don't "provide" private Perl libs
%global _use_internal_dependency_generator 0
%global __deploop() while read FILE; do /usr/lib/rpm/rpmdeps -%{1} ${FILE}; done | sort -u
%global __find_provides /bin/sh -c "grep -v '%{perl_vendorarch}/.*\\.so$' | %{__deploop P}"
%global __find_requires /bin/sh -c "%{__deploop R}"

%description
Sendmail::Milter provides users with the ability to write mail filters in Perl
that tightly integrate with sendmail's mail filter API.

With this module, you can define and register Perl callbacks with the Milter
engine. This module calls your perl callbacks using interpreters from a
threaded persistent interpreter pool. Milter contexts are presented using an
object-oriented style interface for performing operations on a Milter context.

%prep
%setup -q -n Sendmail-Milter-%{version}

# Fix build scripts to work in Fedora environment
%patch0 -p0

# Fix CPAN RT#48644 (parsing bug in auto_getconn)
%patch1 -p1

%build
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE='%{optflags}'
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install PERL_INSTALL_ROOT=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
find %{buildroot} -type f -name '*.bs' -a -size 0 -exec rm -f {} ';'
find %{buildroot} -depth -type d -exec rmdir {} ';' 2>/dev/null
chmod -R u+w %{buildroot}

%check
make test

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc README* Changes LICENSE TODO
%{perl_vendorarch}/Sendmail/
%{perl_vendorarch}/auto/Sendmail/
%{_mandir}/man3/Sendmail::Milter.3pm*

%changelog
* Wed Oct 19 2011 Paul Howarth <paul@city-fan.org> 0.18-11
- Nobody else likes macros for commands
- Update dist tag macros

* Thu Sep 24 2009 Paul Howarth <paul@city-fan.org> 0.18-10
- Add patch for CPAN RT#48644 (parsing bug in auto_getconn)
- Define RPM macros in global scope
- Don't provide Milter.so

* Wed Jun  6 2007 Paul Howarth <paul@city-fan.org> 0.18-9
- Fix dist tag for Fedora 7 onwards
- Add buildreq perl(ExtUtils::MakMaker)
- Fix argument order for find with -depth
- Use search.cpan.org download URL
- Add note about x86_64 build problems and using Sendmail::PMilter instead

* Fri Sep  1 2006 Paul Howarth <paul@city-fan.org> 0.18-8
- Simplify distribution-detection
- Remove macro %%{__perl_version}, used only once
- Remove macro %%{__perl_package}, used only twice
- Define %%{__id_u} in a more portable way
- Use search.cpan.org download URL
- Don't use macros in command paths, hardcode them instead
- Clear buildroot unconditionally in %%clean and %%install
- Fix directory ownership
- Simplify compiler optimization flag setting

* Fri Jun  3 2005 Paul Howarth <paul@city-fan.org> 0.18-7
- Rewrite spec file in (mainly) Fedora Extras style
- Include full URL for source
- Use MODULE_COMPAT dependency style and remove explicit perl dependency
- Remove MANIFEST from %%doc

* Tue Aug 17 2004 Paul Howarth <paul@city-fan.org> 0.18-6
- General tidy-up of spec file.
- Add note about difficulty building on RHEL3/x86_64.

* Thu Apr 15 2004 Paul Howarth <paul@city-fan.org> 0.18-5
- Added explicit perl dependency to ensure that an RPM built on a
  system with an updated version of perl (and hence having files
  installed in a place that a non-updated system won't find them)
  will not install on the non-updated system. In such cases, just
  rebuild from the source RPM.
- Changed distribution-identifying macros for greater portability.

* Mon Feb 16 2004 Paul Howarth <paul@city-fan.org> 0.18-4
- Unified spec file for Red Hat and Fedora Core

* Wed Feb 11 2004 Paul Howarth <paul@city-fan.org> 0.18-3.fc1
- Removed explicit build requirement of the libmilter include
  files, since they *are* included in the stock Fedora
  sendmail-devel. D'oh!
- Tidy up install section.

* Thu Jan 22 2004 Paul Howarth <paul@city-fan.org> 0.18-2.fc1
- Added explicit build requirement of the libmilter include
  files, since it turns out the stock Fedora RPM doesn't
  include them.

* Fri Jan 09 2004 Paul Howarth <paul@city-fan.org> 0.18-1.fc1
- Initial build
